{ Algorithm: Sort: Bubble Sort }
program bubbleSort(output);
const n = 100;
type table = array[1..n] of integer;
var a : table;

{ Bubble Sort Algorithm }
procedure sort(var t : table);
var i,j,w : integer;
begin
	for i := 1 to n-1 do begin
		for j := i+1 to n do begin
			if t[i] > t[j] then begin
				{ swap i and j }
				w := t[i];
				t[i] := t[j];
				t[j] := w;
			end;
		end;
	end;
end;

{ Create Input Data }
procedure init(var t : table);
var i : integer;
begin
	for i := 1 to n do t[i] := trunc(random * 1000);
end;

{ Print Data }
procedure print(var t : table);
var i : integer;
begin
	for i:= 1 to n do begin
		write(t[i]:4);
		if 0 = i mod 10 then writeLn;
	end;
end;

{ Main }
begin
	init(a);
	writeLn('Input Data:');
	print(a);
	writeLn;
	sort(a);
	writeLn('Sorted Data:');
	print(a);
end.
