{ Algorithm: Sort: Shell Sort }
program ShellSort(output);
const n = 100;
type table = array[1..n] of integer;
var a : table;

{ Shell Sort Algorithm }
procedure sort(var t : table);
var i,j,k,w,step : integer;
	br : Boolean;
begin
	step := 1;
	while step < n div 9 do step := step * 3 + 1;
	
	while 0 < step do begin
		for i := step+1 to n do begin
			w := t[i];
			j := i;
			br := false;
			repeat
				if t[j-step] > w then begin
					t[j] := t[j-step];
					j := j - step;
				end else begin
					br := true;
				end;
			until (step >= j) or br;
			t[j] := w;
		end;
		step := step div 3;
	end;
end;

{ Create Input Data }
procedure init(var t : table);
var i : integer;
begin
	for i := 1 to n do t[i] := trunc(random * 1000);
end;

{ Print Data }
procedure print(var t : table);
var i : integer;
begin
	for i:= 1 to n do begin
		write(t[i]:4);
		if 0 = i mod 10 then writeLn;
	end;
end;

{ Main }
begin
	init(a);
	writeLn('Input Data:');
	print(a);
	writeLn;
	sort(a);
	writeLn('Sorted Data:');
	print(a);
end.
