{ linear link list }
program attend(input,output);
type nodep  = ^node;
     node   = record value : integer;
	             left, right : nodep
	      end;		       
     chunkp = ^chunk;
     chunk  = record value : integer;
	       prev, next : chunkp
	    end;
var f	     : text;
   top	     : nodep;
   primitive : chunkp;
   i	     : integer;

procedure  addNode(v : integer);
label 10;
var np, mp : nodep;
begin
   mp := top;
   writeln('mp=', mp^.value, ' top=', top^.value);
   new(np);
   np^.value := v;
   np^.left := nil;
   np^.right := nil;
   10:
      if mp^.value >= v then
	 if mp^.left = nil then
	    mp^.left := np
	 else begin
	    mp := mp^.left;
	    goto 10
	 end
      else
	 if mp^.right = nil then
	    mp^.right := np
	 else begin
	    mp := mp^.right;
	    goto 10
	 end
end; { addNode }

procedure printNode(np : nodep);
begin
   write(np^.value:2);
   write('(');
   if np^.left <> nil then printNode(np^.left);
   write(':');
   if np^.right <> nil then printNode(np^.right);
   write(')')
end; { printNode }

procedure addChunk(v  : integer );
label 10;
var cp,dp : chunkp;
procedure hinsert(inc,posc : chunkp);
var scp	: chunkp;
begin
   scp := posc^.next;
   scp^.prev := inc;
   inc^.next := scp;
   posc^.next := inc;
   inc^.prev := posc
end; { hinsert }
   
begin
   new(cp);
   cp^.value := v;
   dp := primitive;
   10:
   if dp^.value >= v then
      if dp^.prev = primitive then begin
	 dp^.prev := cp;
	 cp^.next := dp;
	 cp^.prev := primitive
      end
      else if dp^.prev^.value <= v then
	 hinsert(cp,dp^.prev)
      else begin
	 dp := dp^.prev;
	 goto 10
      end
    else
      if dp^.next = primitive then begin
	 dp^.next := cp;
	 cp^.prev := dp;
	 cp^.next := primitive
      end
      else if dp^.next^.value >= v then
	 hinsert(cp,dp)
      else begin
	 dp := dp^.next;
	 goto 10
      end
end; { addChunk }

procedure printChunk(key : chunkp);
var minc : chunkp;
begin
   minc := key;
   while primitive <> minc^.prev do
      minc := minc^.prev;
   while primitive <> minc^.next do begin
      write(minc^.value, '<');
      minc := minc^.next
   end;
   minc := minc^.next;
   while primitive <> minc^.next do begin
      write(minc^.value, '<');
      minc := minc^.next
   end;
   write(minc^.value)
end; { printChunk }
      
begin
   new(top);
   top^.left := nil;
   top^.right := nil;
   new(primitive);
   primitive^.prev := primitive;
   primitive^.next := primitive;

   writeln('Input: [C-d] to end');
   readln(i);
   top^.value := i;
   primitive^.value := i;
   while not eof do begin
      readln(i);
      addNode(i);
      writeln('addNode Complete');
      addChunk(i);
      writeln('addChunk Complete');
   end;
   printNode(top);
   writeln;
   writeln;
   printChunk(primitive);
   writeln
end.
      