{ Algorithm: Pattern Matching: Brute-Force Matching }
program bruteForceMatching(input,output,script);
const maxlen = 20;
	maxline = 1024;
type word = packed array[0..maxlen] of char;
	line = packed array[0..maxline] of char;
	
var script : text;
	w : word;

{ Brute-Force Matching Algorithm }
function match(var key : word; var buf : line; start : integer) : integer;
var i, j, k, len : integer;
	cont : Boolean;
begin
	buf[maxline] := chr(0);
	key[maxlen] := chr(0);
	
	cont := true;
	i := 0;
	j := start;
	k := -1;

	if maxline <= start then cont := false;
	while cont do begin
		if chr(0) = key[i] then begin
			k := j - i;
			cont := false;
		end else if chr(0) = buf[j] then begin
			cont := false;
		end else if key[i] = buf[j] then begin
			i := i + 1;
			j := j + 1;
		end else begin
			j := 1 + j - i;
			i := 0;
		end;
	end;
	match := k;
end;

{ Read Text }
procedure matchText(var key : word);
var buf : line;
	i,m,n,rows,count : integer;
begin
	reset(script);
	count := 0;
	rows := 0;
	while not eof(script) do begin
		readLn(script, buf);
		rows := rows + 1;
		m := 1;
		n := match(key, buf, 0);
		if 0 <= n then begin
			writeLn('Found in line ', rows, ' (hit return to continue):');
			writeLn(buf);
			repeat
				count := count + 1;
				for i := m to n do write(' ');
				write('^');
				m := n + 2;
				n := match(key, buf, n + 1);
			until 0 > n;
			writeLn;
			readLn;
		end;
	end;
	writeLn('Total ', count, ' times found');
end;

{ Main Routine }
begin
	write('Pattern: ');
	readLn(w);
	matchText(w);
end.
