{ Algorithm: Sort: Recursive Quick Sort }
program recursiveQuickSort(output);
const n = 100;
type table = array[1..n] of integer;
var a : table;

{ Recursive Quick Sort Algorithm }
procedure sortRec(var t : table; min, max : integer);
var i,j,pivot,w : integer;
begin
	if min < max then begin
		pivot := t[max];
		i := min;
		j := max - 1;
		while t[i] < pivot do i := i + 1;
		while (i < j) and (t[j] > pivot) do j := j - 1;
		while i < j do begin
			w := t[i];
			t[i] := t[j];
			t[j] := w;
			while t[i] < pivot do i := i + 1;
			while (i < j) and (t[j] > pivot) do j := j - 1;
			while (i < j) and (t[i] = pivot) and (t[j] = pivot) do begin
				i := i + 1;
				j := j - 1;
			end;
		end;
		w := t[i];
		t[i] := pivot;
		t[max] := w;
		sortRec(t,min,i-1);
		sortRec(t,i+1,max);
	end;
end;

procedure sort(var t : table);
begin
	sortRec(t, 1, n);
end;

{ Create Input Data }
procedure init(var t : table);
var i : integer;
begin
	for i := 1 to n do t[i] := trunc(random * 1000);
end;

{ Print Data }
procedure print(var t : table);
var i : integer;
begin
	for i:= 1 to n do begin
		write(t[i]:4);
		if 0 = i mod 10 then writeLn;
	end;
end;

{ Main }
begin
	init(a);
	writeLn('Input Data:');
	print(a);
	writeLn;
	sort(a);
	writeLn('Sorted Data:');
	print(a);
end.
