{ Hit and Blow }
program hitAndBlow(input, output);
var k, m, h1, turns, hits, blows : integer;
	digits : array [0..9] of integer;
	q, r : array [1..4] of integer;
	seed, i, j : integer;
	isdebug : boolean;

procedure swap(var x, y : integer);
var t : integer;
begin
	t := x;
	x := y;
	y := t
end;

function rand : real;
var r : real;
	i : integer;
begin
	i := abs(seed + 1233);
	r := i;
	r := sqrt(r) * 100.0 + 233.1;
	r := sqrt(314.2) * r;
	i := trunc(r) mod 10000;
	seed := i;
	r := i;
	rand := r / 10000;
end;

begin
(* print logo *)
	writeln('HIT & BLOW  ver 1.0');
	writeln('How to: 1. Input randomizing seed');
	writeln('        2. Guess the number of 4 digits');
	writeln('        * If you wanna give up, input minus value.');
	writeln;
	write('input game number:');
	read(seed);
	isdebug := seed < 0;

(* make number *)
	for i := 0 to 9 do digits[i] := i;
	h1 := trunc(rand * 9.0) + 1;
	swap(digits[9], digits[h1]);
	h1 := trunc(rand * 9.0);
	swap(digits[8], digits[h1]);
	h1 := trunc(rand * 8.0);
	swap(digits[7], digits[h1]);
	h1 := trunc(rand * 7.0);
	swap(digits[6], digits[h1]);
	for i := 1 to 4 do q[i] := digits[5 + i];

(* main loop *)
	turns := 0;
	repeat
		turns := turns + 1;
		writeln;
		if isdebug then writeln(q[4], q[3], q[2], q[1]) else writeln;
		writeln('La la la ... hit and blow');
		write('Hey, you guess, you guess :');
		read(k);
		writeln;
		hits := 0;
		blows := 0;
		if k < 0 then begin
			writeln('Oh, you give up');
			hits := 4;
		end else begin
			h1 := 0;
			for i := 1 to 4 do begin
				r[i] := k mod 10;
				k := k div 10;
				for j := 1 to i do if (r[i] = r[j]) and (i <> j) then h1 := -1
			end;
			
			if h1 <> 0 then writeln('It''s dirty, money')
			else begin
				for i := 1 to 4 do begin
					if q[i] = r[i] then hits := hits + 1
					else begin
						j := 1;
						repeat
							if q[j] = r[i] then begin
								blows := blows + 1;
								j := 4;
							end; 
							j := j + 1
						until j > 4
					end
				end;

				writeln('  Hits: ', hits, '  Blows: ', blows);
				if hits = 4 then begin
					if turns > 15 then
						writeln('Hu, it''s long way')
						else if turns > 10 then
							writeln('You spent good time')
							else if turns > 7 then
								writeln('Wonderful!')
								else if turns > 5 then
									writeln('Very good!')
									else writeln('Perfect!');
					writeln(turns:16, ' turns') 
				end else case (hits + blows) of
					0: writeln('Sorry...');
					1: writeln('Hmm...');
					2: writeln('Steady,');
					3: writeln('Coming up');
					4: writeln('Next to win!')
				end
			end
		end
	until hits = 4
end.