{ Graphics }
#option 'gs'
{
	note: Option 'g' links the first external file to a graphic stream.
}

program graphics(g);
var i, x, y : integer;
	forecolor : integer;
	g : text;

procedure gInit(left,top,right,bottom : integer);
begin
	rewrite(g);
	writeLn(g, 'WINDOW ', abs(right - left), ',', abs(bottom - top));
	writeLn(g, 'VIEW (', left, ',', top, ')-(', right, ',', bottom, ')');
	forecolor := 0;
end;

procedure drawEllipse(left,top,right,bottom:integer);
begin
	writeLn(g, 'ELLIPSE (', left, ',', top, ')-(', right, ',', bottom, '), ', forecolor);
end;

{ Main }
begin
	gInit(-150, -150, 150, 150);
	
	x := 150;
	y := 0;	
	for i := 0 to 10 do begin
		drawEllipse(-x, -y, x, y);
		x := x - 15;
		y := y + 15;
	end;
end.